<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.9.1
--%>

<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"	
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.util.PluginInfo"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);

Map<PluginInfo, Throwable> installationResult = 
	(Map<PluginInfo, Throwable>)sc.getSessionSetting("pluginwizard.installationresult");
sc.setSessionSetting("pluginwizard.installationresult", null);
if (installationResult == null)
{
	response.sendRedirect("../../common/close_popup.jsp?refresh_opener=1&wait=0");
	return;
}
int numPlugins = installationResult.size();
int numFailed = 0;
for (Throwable t : installationResult.values())
{
	if (t != null) numFailed++;
}
int numOk = numPlugins-numFailed;
		
String title = numFailed == 0 ? numPlugins + " plug-ins installed sucessfully" :
	numFailed + " plug-in(s) of " + numPlugins + " could not be completely installed";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="table.js" styles="table.css">
	</base:head>
	<base:body>

		<h3 class="docked"><%=title%></h3>
		<div class="boxed" style="height: <%=(int)(scale*370)+"px;"%>">
			<tbl:table 
				id="installation"
				clazz="itemlist"
			>
			<tbl:columndef 
				id="plugin"
				title="Plug-in"
			/>
			<tbl:columndef 
				id="version"
				title="Version"
			/>
			<tbl:columndef 
				id="result"
				title="Result"
			/>
			<tbl:data>
				<tbl:columns>
				</tbl:columns>
				<tbl:rows>
					<%
					int i = 0;
					for (Map.Entry<PluginInfo, Throwable> entry : installationResult.entrySet())
					{
						i++;
						PluginInfo info = entry.getKey();
						Throwable t = entry.getValue();
						boolean failed = t != null;
						if (t != null && t.getCause() != null) t = t.getCause();
						%>
						<tbl:row>
							<tbl:cell column="plugin"><%=info.getAbout().getName()%></tbl:cell>
							<tbl:cell column="version"><%=info.getAbout().getVersion()%></tbl:cell>
							<tbl:cell column="result" visible="<%=failed%>">
								<span class="link" 
									title="Click to show/hide complete stacktrace"
									onclick="Main.showHide('stacktrace.<%=i%>')">
										<base:icon image="error.gif" /><%=t.getMessage() %></span>
								<div id="stacktrace.<%=i%>" class="stacktrace" 
									style="background: inherit; display: none;"><%=ThrowableUtil.stackTraceToString(t)%></div>
							</tbl:cell>
							<tbl:cell column="result" visible="<%=!failed%>">
								<base:icon image="ok.gif"/>Installed sucessfully
							</tbl:cell>
						</tbl:row>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
			</tbl:table>
		</div>
		<table align="center">
		<tr>
			<td><base:button onclick="window.close();" title="Ok" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
 %>
 