<%-- $Id: edit_biowell.jsp 5459 2010-10-29 12:01:56Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.LabeledExtract"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOWELL;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioWell bioWell = BioWell.getById(dc, itemId);
	BioPlate bioPlate = bioWell.getPlate();
	BioPlateType bioPlateType = bioPlate.getBioPlateType();
	Item bioMaterialType = bioPlateType.getBioMaterialType();
	
	bioWell.checkPermission(Permission.WRITE);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	title = "Edit biowell -- [" + rowFormatter.format(bioWell.getRow()) + ", " + columnFormatter.format(bioWell.getColumn()) + "] on bioplate " + HTML.encodeTags(bioPlate.getName());

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	
	boolean readCurrentBioMaterial = true;
	MeasuredBioMaterial currentBioMaterial = null;
	try
	{
		currentBioMaterial = bioWell.getBioMaterial();
	}
	catch (PermissionDeniedException ex)
	{
		readCurrentBioMaterial = false;
	}
	boolean canAddBioMaterial = bioWell.canAddBioMaterial();

	cc.setObject("item", bioWell);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "BioWell" tab
		function validateBioWell()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['biowell'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.biomaterial_type.disabled = false;
				frm.submit();
			}
		}

		// Biomaterial selection
		function selectBioMaterialOnClick()
		{
			var frm = document.forms['biowell'];
			var typelist = frm.biomaterial_type;			
			if (typelist.selectedIndex == 0)
			{
				alert("You must first select what type of biomaterial");
				return;
			}			
			var type = typelist[typelist.selectedIndex].value;
			var folder = type.toLowerCase();		
			var controller = Main.getController(type);
			var url = getRoot() + controller.url + '?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioMaterialCallback';
			if (frm.biomaterial_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.biomaterial_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:STRING:bioWell='+escape('=');
			Main.openPopup(url, 'Select'+type, 1000, 700);
		}
		function setBioMaterialCallback(id, name)
		{
			var frm = document.forms['biowell'];
			var list = frm.biomaterial_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function bioMaterialTypeOnChange()
		{
			var frm = document.forms['biowell'];
			var list = frm.biomaterial_id;
			list.selectedIndex = 0;
			list.remove(1);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="biowell" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*160)+"px;"%>" 
			position="bottom" switch="switchTab">
		<t:tab id="info" title="Biowell" validate="validateBioWell()" helpid="biowell.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Bioplate</td>
				<td><%=HTML.encodeTags(bioPlate.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Coordinate</td>
				<td>[<%=rowFormatter.format(bioWell.getRow())%>,<%=columnFormatter.format(bioWell.getColumn())%>]</td>
			</tr>
			<tr>
				<td class="prompt">Biomaterial type</td>
				<td>					
					<select name="biomaterial_type" onchange="bioMaterialTypeOnChange()" <%=bioMaterialType != null ? "disabled": ""%>>
						<%
						if (!readCurrentBioMaterial)
						{
							%>
							<option value="-1">- denied -
							<%
						}
						else
						{
							Item currentBmType = currentBioMaterial == null ? null : currentBioMaterial.getType();
							%>
							<option value="0">- none -
							<option value="<%=Item.SAMPLE.name()%>" 
								<%=currentBmType == Item.SAMPLE || bioMaterialType == Item.SAMPLE ? "selected" : ""%>>Sample
							<option value="<%=Item.EXTRACT.name()%>" 
								<%=currentBmType == Item.EXTRACT || bioMaterialType == Item.EXTRACT ? "selected" : ""%>>Extract
							<option value="<%=Item.LABELEDEXTRACT.name()%>" 
								<%=currentBmType == Item.LABELEDEXTRACT || bioMaterialType == Item.LABELEDEXTRACT ? "selected" : ""%>>Labeled extract
							<%
						}
						%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Biomaterial</td>
				<td>
					<base:select 
						id="biomaterial_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioMaterial%>"
						denied="<%=!readCurrentBioMaterial%>"
						recent="<%=null%>"
						newitem="<%=false%>"
						onselect="<%=canAddBioMaterial ? "selectBioMaterialOnClick()" : null%>"
					/>
				</td>
			</tr>
			<%
			if (!canAddBioMaterial && currentBioMaterial != null)
			{
				%>
				<tr>
					<td></td>
					<td>
						<base:note type="warning" style="background: #ffffd8;">
							New biomaterial can't be added to this well if 
							'<%=HTML.encodeTags(currentBioMaterial.getName())%>' is removed.
						</base:note>
					</td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>
		</t:tabcontrol>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
