<%-- $Id: edit_event.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOMATERIALEVENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final Item bioMaterialType = Item.valueOf(request.getParameter("biomaterial_type"));
final int bioMaterialId = Values.getInt(request.getParameter("biomaterial_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioMaterialEvent event = null;
	MeasuredBioMaterial bioMaterial = null;
	Date eventDate = null;
	
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	
	if (itemId == 0)
	{
		title = "Create event";
		cc.removeObject("item");
		eventDate = (Date)cc.getPropertyObject("eventDate");
	}
	else
	{
		event = BioMaterialEvent.getById(dc, itemId);
		eventDate = event.getEventDate();
		title = "Edit event";
		cc.setObject("item", event);
		
		try
		{
			currentProtocol = event.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
	}
	if (event != null && !event.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Event" tab
		function validateEvent()
		{
			var frm = document.forms['event'];
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['event'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}

		function selectProtocolOnClick()
		{
			var frm = document.forms['event'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['event'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		function init()
		{
			<%
			if (event == null)
			{
				%>
				var frm = document.forms['event'];
				frm.event_date.focus();
				frm.event_date.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="event" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="biomaterial_type" value="<%=bioMaterialType.name()%>">
		<input type="hidden" name="biomaterial_id" value="<%=bioMaterialId%>">

		<h3 class="docked"><%=title%></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*250)+"px;"%>" 
			position="bottom" remember="<%=event != null%>">
		<t:tab id="info" title="Event" validate="validateEvent()">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Event date</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" 
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate == null ? new Date() : eventDate))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Event date', 'event', 'event_date', null, '"+jsDateFormat+"')"%>"
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Used quantity</td>
				<td><input <%=clazz%> type="text" name="used_quantity" 
					value="<%=Values.formatNumber(event == null ? null : event.getUsedQuantity(), -1)%>" size="12" 
					maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						newitem="<%=event == null%>"
						onselect="selectProtocolOnClick()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Comment</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" 
						name="comment" wrap="virtual"><%=HTML.encodeTags(event == null ? cc.getPropertyValue("comment") : event.getComment())%></textarea>
					<a href="javascript:Main.zoom('Comment', 'event', 'comment')" title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
