<%-- $Id: view_help.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http://base.thep.lu.se/
	Copyright (C) 2006 Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Open a popupwindow viewing a particular helpsection.

	@param helpid The externalid of the helpsection to display.

	@author Martin
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Help"	
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.SessionControl"		
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.regex.Pattern"
	import="java.util.regex.Matcher"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
private static final Pattern findTag = Pattern.compile("\\{\\@(\\w+)\\s([^\\s]+)\\s*(.*)\\}");
private String parseTags(String ID, Help help, int includeLevel)
{
	StringBuffer sb = new StringBuffer();
	Matcher m = findTag.matcher(help.getDescription());
	while (m.find())
	{
		String cmd = m.group(1);
		if ("link".equals(cmd))
		{
			m.appendReplacement(sb, "<a href=\"view_help.jsp?ID="+ID+"&external_id=$2\">$3</a>");	
		}
		else if ("include".equals(cmd))
		{
			if (includeLevel >= 10)
			{
				m.appendReplacement(sb, "[<a href=\"view_help.jsp?ID="+ID+"&external_id=$2\">$2</a>]");
			}
			else
			{
				String externalId = m.group(2);
				Help included = null;
				try
				{
					Client c = help.getClient();
					DbControl dc = help.getDbControl();
					included = c.getHelpByExternalId(dc, externalId, false);
				}
				catch (Throwable t)
				{}
				if (included != null)
				{
					String includedHelp = parseTags(ID, included, includeLevel+1);
					m.appendReplacement(sb, includedHelp);
				}
			}
		}
		else
		{
			m.appendReplacement(sb, "cmd=$1, id=$2, rest=$3");
		}
	}
	m.appendTail(sb);
	return sb.toString();
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
final int clientId = sc.getClientId();

String externalId = request.getParameter("external_id");

try
{
	Client c = Client.getById(dc, clientId);
	Help help = null;
	String title = "Help is not available";
	String description = null;
	boolean writePermission = c.hasPermission(Permission.WRITE);
	
	try
	{
		help = c.getHelpByExternalId(dc, externalId, false);
		title = help.getName();
		description = parseTags(ID, help, 0);
		writePermission = help.hasPermission(Permission.WRITE);
	}
	catch (ItemNotFoundException ex)
	{}
%>

	<base:page type="popup" title="Help">
	<base:head styles="help.css">
	<script language="JavaScript">
	function editHelpText()
	{
		Main.viewOrEditItem('<%=ID%>', 'HELP', <%=help == null ? 0 : help.getId()%>, true, '&client_id=<%=clientId%>&external_id=<%=externalId%>');
	}
	</script>
	</base:head>
	<base:body>
		
		<h3 class="docked"><%=title%></h3>
		<div class="boxed" style="height: <%=(int)(scale*440)%>px; overflow: auto;">
		<%
		if (help == null || description == null)
		{
			%>
			<div class="error">
			<br>
			The help text for the section <b><%=externalId%></b> is not
			written yet.
			<br><br>
			</div>
			<%
		}
		else
		{
			%>
			<div class="helptext">
			<%=description%>
			</div>
			<%
		}
		%>
		</div>
		<br>
		<base:buttongroup align="center">
			<base:button image="edit.gif" title="Edit&hellip;" 
				onclick="editHelpText()" visible="<%=writePermission && description != null%>" 
				tooltip="Edit this help text" />
			<base:button image="new.gif" title="Create&hellip;"
				onclick="editHelpText()" visible="<%=writePermission && description == null%>"
				tooltip="Create this help text" />
			<base:button image="back.gif" title="Back" onclick="history.go(-1)" />
			<base:button title="Close" 
				onclick="window.close()" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
