<%-- $Id: select_plugin.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ContextUtil"
	import="net.sf.basedb.util.ContextUtil.ContextResult"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
final Plugin.MainType mainType = Plugin.MainType.valueOf(request.getParameter("main_type"));
final GuiContext context = new GuiContext(itemType, contextType);
final String title = request.getParameter("title");
final String message = request.getParameter("message");
final DbControl dc = sc.newDbControl();
final float scale = Base.getScale(sc);
final boolean anotherIsOpen = sc.getSessionSetting("plugin.configure.plugin") != null;

try
{
	List<ContextResult> contextResults = (List<ContextResult>)sc.getSessionSetting("PLUGINS");
	Set<String> messages = (Set<String>)sc.getSessionSetting("MESSAGES");
	StringBuilder descriptions = new StringBuilder();
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="plugin.js">
		<script language="JavaScript">
		function doNext()
		{
			var frm = document.forms['plugin'];
			var anotherIsOpen = <%=anotherIsOpen%>;
			if (anotherIsOpen)
			{
				if (!confirm('Are you sure? Unsaved settings in the other wizard will be lost.')) return;
				frm.warnIfOpen.value = '0';
			}
			frm.submit();
		}
		
		var lastSelectedPlugin;
		var lastSelectedConfig;
		function pluginOnChange()
		{
			var frm = document.forms['plugin'];
			var pluginList = frm.plugins;
			var plugin = pluginList[pluginList.selectedIndex].plugin;
			var config = pluginList[pluginList.selectedIndex].configuration;

			if (lastSelectedPlugin)
			{
				Main.hide('description.'+lastSelectedPlugin.id);
			}
			if (lastSelectedConfig)
			{
				Main.hide('description.config.'+lastSelectedConfig.id);
			}
			if (plugin)
			{
				Main.show('description.'+plugin.id);
				frm.plugindefinition_id.value = plugin.id;
				frm.pluginconfiguration_id.value = 0;
			}
			if (config)
			{
				Main.show('description.config.'+config.id);
				frm.pluginconfiguration_id.value = config.id;
			}
			lastSelectedConfig = config;
			lastSelectedPlugin = plugin;
		}
		
		function init()
		{
			var frm = document.forms['plugin'];
			var pluginList = frm.plugins;
			<%
			PluginDefinition lastPlugin = null;
			for (ContextResult result : contextResults)
			{
				if (result.isInContext())
				{
					PluginDefinition pd = result.getPluginDefinition();
					if (!pd.equals(lastPlugin))
					{
						lastPlugin = pd;
						dc.reattachItem(pd, false);
						String supportsConfig = pd.supportsConfigurations() ? "true" : "false";
						String requiresConfig = pd.requiresConfiguration() ? "true" : "false";
						descriptions.append("<div id=\"description." + pd.getId() +"\" style=\"display: none;\">");
						descriptions.append(HTML.niceFormat("<b>" + pd.getName() + "</b>\n" + Values.getString(pd.getDescription())));
						descriptions.append("</div>");
						%>
						var thePlugin = new Plugin(<%=pd.getId()%>, '<%=HTML.javaScriptEncode(pd.getName())%>', false, <%=supportsConfig%>, <%=requiresConfig%>);
						<%
					}
					PluginConfiguration pc = result.getPluginConfiguration();
					if (pc != null)
					{
						descriptions.append("<div id=\"description.config." + pc.getId() + "\" style=\"display: none; padding-top: 6px;\">");
						descriptions.append(HTML.niceFormat("<b>" + pc.getName() + "</b>\n" +Values.getString(pc.getDescription())));						
						descriptions.append("</div>");
						%>
						thePlugin.addConfiguration(<%=pc.getId()%>, '<%=HTML.javaScriptEncode(pc.getName())%>');
						<%
					}
				}
			}
			%>
			Plugins.populateLists(pluginList);
			pluginOnChange();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="plugin" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="NewJob">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext%>">
		<input type="hidden" name="context_type" value="<%=contextType.name()%>">
		<input type="hidden" name="main_type" value="<%=mainType.name()%>">
		<input type="hidden" name="title" value="<%=title%>">
		<input type="hidden" name="warnIfOpen" value="1">
		<input type="hidden" name="plugindefinition_id" value="">
		<input type="hidden" name="pluginconfiguration_id" value="">

		<h3 class="docked"><%=title%> <base:help helpid="runplugin.selectplugin" /></h3>
		<div class="boxed" style="height: <%=(int)(scale*420)%>px; overflow: auto;">
			<div class="helpmessage">
			<%
			if (message != null)
			{
				%>
				<%=message%>
				<%
			}
			else
			{
				%>
				Please select the plugin and, optionally, the configuration to use.
				<%
			}
			%>
			</div>
		
			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt">Plugin + configuration</td>
				<td>
					<select name="plugins" class="required" onchange="pluginOnChange()">
					</select>
				</td>
			</tr>
			<%
			if (messages != null && messages.size() > 0)
			{
				%>
				<tr>
					<td class="prompt">&nbsp;</td>
					<td>
						<base:icon image="bullet.gif" />
						<a href="javascript:Main.showHide('pluginMessages')" 
							title="Show/hide the messages from the plugins that couldn't be used">
						Some plugins couldn't be used
						</a>
						<div id="pluginMessages" style="display: none;">
						<ul>
						<li><%=Values.getString(messages, "<li>", true)%>
						</ul>
						</div>
					</td>
				</tr>
				<%
			}
			%>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
			<div id="descriptions" class="helpmessage" 
				style="height: <%=(int)(scale*270)%>px; overflow: auto;">
			<%=descriptions.toString()%>
			</div>
		</div>
		</form>
	
		<%
		if (anotherIsOpen)
		{
			%>
			<div class="error">
				Another plug-in configuration wizard is open, or it hasn't properly 
				clean up after itself.<br>
				If you continue unsaved settings in the other wizard is lost.
			</div>
			<%
		}
		%>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doNext();" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

