<%-- $Id: ajax.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SimpleAbsoluteProgressReporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.util.AjaxWriter"
	import="net.sf.basedb.clients.web.fileupload.FileUploadProgress"
	import="net.sf.basedb.clients.web.fileupload.UploadAbortedException"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
out.clear();
AjaxWriter aw = new AjaxWriter(out);
try
{
	if ("GetProgress".equals(cmd))
	{
		final FileUploadProgress progress = (FileUploadProgress)sc.getSessionSetting("FileUploadProgress");
		final SimpleAbsoluteProgressReporter unpackProgress = (SimpleAbsoluteProgressReporter)sc.getSessionSetting("UnpackProgress");

		if (unpackProgress != null)
		{
			aw.ajaxPrintEntry("message", unpackProgress.getMessage());
		}
		if (progress != null)
		{
			Throwable exception = progress.getException();
			if (exception != null && exception.getMessage() != null) 
			{
				aw.ajaxPrintEntry("message", exception.getMessage());
			}
			aw.ajaxPrintEntry("file", progress.getCurrentFilename());
			aw.ajaxPrintEntry("bytes.total", progress.getTotalBytes());
			aw.ajaxPrintEntry("bytes.transferred", progress.getTransferredBytes());
			aw.ajaxPrintEntry("time.seconds", progress.getMillisecondsSinceStart() / 1000);
		}
		aw.ajaxEndRecord();

	}
	else if ("Abort".equals(cmd))
	{
		final FileUploadProgress progress = (FileUploadProgress)sc.getSessionSetting("FileUploadProgress");
		if (progress != null) progress.setAbort();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	aw.flush();
}
%>