<%-- $Id: test_nullplugin.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.PluginParameter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String clazz = "class=\"text\"";
final String requiredClazz = "class=\"text required\"";
try
{
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	if (pcRequest == null) throw new WebException("popup", "No request information found", "No request information found");
	PluginDefinition plugin = (PluginDefinition)sc.getSessionSetting("plugin.configure.plugin");
	PluginConfiguration pluginConfig = (PluginConfiguration)sc.getSessionSetting("plugin.configure.config");
	
	RequestInformation ri = pcRequest.getRequestInformation();
	String title = HTML.encodeTags(ri.getTitle());
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head >
		<script language="JavaScript">
		
		function saveSettings()
		{
			var frm = document.forms['configure'];
			frm.submit();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="configure" onsubmit="return false;">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="title" value="<%=title%>">
		<h3 class="docked"><%=title%></h3>
		<div class="boxed">
			
			<div class="pluginhelp">
				<%=HTML.niceFormat(ri.getDescription())%>
			</div>
		
			<table class="form">
			<tr valign="top">
				<td class="prompt">Plugin</td>
				<td><%=plugin.getName()%></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Configuration</td>
				<td><%=pluginConfig.getName()%></td>
			</tr>
			<tr>
				<td class="prompt">One string</td>
				<td><input type="text" <%=requiredClazz%> name="parameter:oneString"
					value="<%=HTML.encodeTags((String)pluginConfig.getParameterValues("oneString").get(0))%>" 
					size="40"></td>
			</tr>
			<tr>
				<td class="prompt">Many strings</td>
				<td>
					<table>
					<%
					List<String> manyStrings = (List<String>)pluginConfig.getParameterValues("manyStrings");
					int i = 0;
					for (String aString : manyStrings)
					{
						i++;
						%>
						<tr>
						<td><%=i%></td>
						<td><input type="text" <%=requiredClazz%> name="parameter:manyStrings"
							value="<%=HTML.encodeTags(aString)%>" size="40"></td>
						</tr>
						<%
					}
					%>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Select one</td>
				<td>
					<select name="parameter:selectOneString" class="required">
					<%
					PluginParameter<String> selectOne = (PluginParameter<String>)ri.getParameter("selectOneString");
					String defaultSelected = (String)pluginConfig.getParameterValues("selectOneString").get(0);
					for (String aString : selectOne.getParameterType().getItems())
					{
						String encoded = HTML.encodeTags(aString);
						String selected = aString.equals(defaultSelected) ? "selected" : "";
						%>
						<option value="<%=encoded%>" <%=selected%>><%=encoded%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Select one or more</td>
				<td>
					<select name="parameter:selectMultipleStrings" class="required" multiple size="5">
					<%
					PluginParameter<String> selectMultiple = (PluginParameter<String>)ri.getParameter("selectMultipleStrings");
					List<String> defaultSelection = (List<String>)pluginConfig.getParameterValues("selectMultipleStrings");
					for (String aString : selectMultiple.getParameterType().getItems())
					{
						String encoded = HTML.encodeTags(aString);
						String selected = defaultSelection.contains(aString) ? "selected" : "";
						%>
						<option value="<%=encoded%>" <%=selected%>><%=encoded%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			</table>
			<div align="right">
			<base:icon image="required.gif" /> = <i>required information</i>
			</div>
		</div>
		</form>
		
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	
}
%>
